<?php

namespace App\Filament\Resources;

use App\Filament\Exports\WorkGroupMasterExporter;
use App\Filament\Imports\WorkGroupMasterImporter;
use App\Filament\Resources\WorkGroupMasterResource\Pages;
use App\Filament\Resources\WorkGroupMasterResource\RelationManagers;
use App\Models\Line;
use App\Models\Plant;
use App\Models\WorkGroupMaster;
use Filament\Forms;
use Filament\Forms\Form;
use Filament\Resources\Resource;
use Filament\Tables;
use Filament\Tables\Table;
use Illuminate\Database\Eloquent\Builder;
use Illuminate\Database\Eloquent\SoftDeletingScope;
use Filament\Forms\Components\Section;
use Filament\Facades\Filament;
use Filament\Tables\Actions\ImportAction;
use Filament\Tables\Actions\ExportAction;
use Illuminate\Validation\Rule;

class WorkGroupMasterResource extends Resource
{
    protected static ?string $model = WorkGroupMaster::class;

    protected static ?string $navigationIcon = 'heroicon-o-rectangle-stack';

    protected static ?string $navigationGroup = 'Master Entries';

    protected static ?int $navigationSort = 11;

    public static function form(Form $form): Form
    {
        return $form
            ->schema([
                Section::make('')
                ->schema([
                Forms\Components\Select::make('plant_id')
                    ->label('Plant')
                    ->relationship('plant', 'name')
                    ->reactive()
                    ->columnSpan(1)
                    ->required()
                    ->options(function (callable $get) {
                        $userHas = Filament::auth()->user()->plant_id;
                        return ($userHas && strlen($userHas) > 0) ? Plant::where('id', $userHas)->pluck('name', 'id')->toArray() : Plant::pluck('name', 'id')->toArray();
                    })
                    ->afterStateUpdated(function ($state, $set, callable $get) {
                        $plantId = $get('plant_id');

                        if (!$plantId) {
                            $set('pqPlantError', 'Please select a plant first.');
                            $set('name', null);
                            $set('description', null);
                            $set('operation_number', null);
                            return;
                        }

                        $set('validationError', null);
                        $set('pqPlantError', null);
                        $set('name', null);
                        $set('description', null);
                        $set('operation_number', null);
                    })
                    ->hint(fn ($get) => $get('pqPlantError') ? $get('pqPlantError') : null)
                    ->hintColor('danger'),
                Forms\Components\TextInput::make('name')
                    ->label('Name')
                    ->required()
                    ->minLength(6)
                    ->columnSpan(1)
                    ->reactive()
                    ->rule(function (callable $get) {
                            return Rule::unique('work_group_masters', 'name')
                                ->where('plant_id', $get('plant_id'))
                                ->ignore($get('id'));
                    }),
                Forms\Components\TextInput::make('operation_number')
                    ->label('Operation Number')
                    ->numeric()
                    ->columnSpan(1)
                    ->reactive()
                    ->required()
                    ->rule(function (callable $get) {
                            return Rule::unique('work_group_masters', 'operation_number')
                                ->where('plant_id', $get('plant_id'))
                                ->ignore($get('id'));
                    }),
                Forms\Components\TextInput::make('description')
                    ->label('Description')
                    ->required()
                    ->minLength(5)
                    ->reactive()
                    ->columnSpan(['default' => 1, 'sm' => 3]),
                Forms\Components\Hidden::make('created_by')
                    ->default(Filament::auth()->user()?->name),
                ])
               ->columns(['default' => 1, 'sm' => 3]),
            ]);
    }

    public static function table(Table $table): Table
    {
        return $table
            ->columns([
                Tables\Columns\TextColumn::make('No.')
                    ->label('No.')
                    ->getStateUsing(function ($record, $livewire, $column, $rowLoop) {
                        $paginator = $livewire->getTableRecords();
                        $perPage = method_exists($paginator, 'perPage') ? $paginator->perPage() : 10;
                        $currentPage = method_exists($paginator, 'currentPage') ? $paginator->currentPage() : 1;
                        return ($currentPage - 1) * $perPage + $rowLoop->iteration;
                    }),
                Tables\Columns\TextColumn::make('plant.name')
                    ->label('Plant')
                    ->alignCenter()
                    ->searchable()
                    ->sortable(),
                Tables\Columns\TextColumn::make('name')
                    ->label('Name')
                    ->alignCenter()
                    ->searchable()
                    ->sortable(),
                Tables\Columns\TextColumn::make('description')
                    ->label('Description')
                    ->alignCenter()
                    ->searchable()
                    ->sortable(),
                Tables\Columns\TextColumn::make('operation_number')
                    ->label('Operation Number')
                    ->alignCenter()
                    ->searchable()
                    ->sortable(),
                Tables\Columns\TextColumn::make('created_by')
                    ->label('Created By')
                    ->alignCenter()
                    ->searchable()
                    ->sortable(),
                Tables\Columns\TextColumn::make('created_at')
                    ->label('Created At')
                    ->alignCenter()
                    ->dateTime()
                    ->sortable()
                    ->toggleable(isToggledHiddenByDefault: true),
                Tables\Columns\TextColumn::make('updated_at')
                    ->label('Updated At')
                    ->alignCenter()
                    ->dateTime()
                    ->sortable()
                    ->toggleable(isToggledHiddenByDefault: true),
                Tables\Columns\TextColumn::make('deleted_at')
                    ->label('Deleted At')
                    ->alignCenter()
                    ->dateTime()
                    ->sortable()
                    ->toggleable(isToggledHiddenByDefault: true),
            ])
            ->filters([
                Tables\Filters\TrashedFilter::make(),
            ])
            ->actions([
                Tables\Actions\ViewAction::make(),
                Tables\Actions\EditAction::make(),
            ])
            ->bulkActions([
                Tables\Actions\BulkActionGroup::make([
                    Tables\Actions\DeleteBulkAction::make(),
                    Tables\Actions\ForceDeleteBulkAction::make(),
                    Tables\Actions\RestoreBulkAction::make(),
                ]),
            ])
            ->headerActions([
                ImportAction::make()
                    ->label('Import Work Group Masters')
                    ->color('warning')
                    ->importer(WorkGroupMasterImporter::class)
                    ->visible(function() {
                        return Filament::auth()->user()->can('view import work group master');
                    }),
                ExportAction::make()
                    ->label('Export Work Group Masters')
                    ->color('warning')
                    ->exporter(WorkGroupMasterExporter::class)
                    ->visible(function() {
                        return Filament::auth()->user()->can('view export work group master');
                    }),
            ]);
    }

    public static function getRelations(): array
    {
        return [
            //
        ];
    }

    public static function getPages(): array
    {
        return [
            'index' => Pages\ListWorkGroupMasters::route('/'),
            'create' => Pages\CreateWorkGroupMaster::route('/create'),
            'view' => Pages\ViewWorkGroupMaster::route('/{record}'),
            'edit' => Pages\EditWorkGroupMaster::route('/{record}/edit'),
        ];
    }

    public static function getEloquentQuery(): Builder
    {
        return parent::getEloquentQuery()
            ->withoutGlobalScopes([
                SoftDeletingScope::class,
            ]);
    }
}
